//include librarys //
#include <Servo.h>           //#include  'greater than' Servo.h 'less than'

int moveTime = 8;   // time delay to allow servos to move 1 step
int stepSize = 2;   // 1 step of the servonn [degrees]

//Define buttons//
const int leftButton = 19;   //  D19=A5
const int leftStick = 18;    //  D18 = A4
const int rightStick = 17;   //  A3
const int upStick = 16;      //  A2
const int downStick = 15;    //  A1
const int rightButton = 14;  //  A0

//Define variable for button state//
int leftButtonState = HIGH;        // 1 = open
int leftStickState = HIGH;         // 0 = closed 
int rightStickState = HIGH;
int upStickState = HIGH;
int downStickState = HIGH;
int rightButtonState = HIGH; 

// create servos// 
Servo servoHead;
Servo servoArmR;
Servo servoArmL;
Servo servoBend;
Servo servoTwist;

//Define variables //

int posHead  = 90;                //'home' positions
int posArmR = 0;
int posArmL = 180;
int posBend  = 160;
int posTwist = 100;

int dirArm = 1;
int dirHead = 1;

void setup()
{
// attach servos //
servoHead.attach(11);
servoArmR.attach(10);
servoArmL.attach(9);
servoBend.attach(6);
servoTwist.attach(5);

//set pinmodes
pinMode(leftButton, INPUT);
pinMode (leftStick, INPUT); 
pinMode (rightStick, INPUT);
pinMode (upStick, INPUT);
pinMode (downStick, INPUT);
pinMode (rightButton, INPUT);

}

void loop()
{
//read all buttons//
leftButtonState = digitalRead(leftButton);          // 1 = open
leftStickState = digitalRead(leftStick);         // 0 = closed
rightStickState = digitalRead(rightStick);
upStickState = digitalRead(upStick);
downStickState = digitalRead(downStick);
rightButtonState = digitalRead(rightButton);

/*
//attach all servos
servoHead.attach(11);
servoArmR.attach(10);
servoArmL.attach(9);
servoBend.attach(6);
servoTwist.attach(5);
*/
//update positions//

if (leftButtonState == LOW){                 
  if (posArmL > 180){
    dirArm = -dirArm;                        //reverse
  }
  if(posArmL == 0){
    dirArm = -dirArm;
  }
  posArmL = posArmL + (dirArm * stepSize);              //go
  posArmR = posArmL;                        // left botton controlls both arms
}
  
if (downStickState == LOW){                 
  if (posBend != 180){              // if not at the max
  posBend = posBend + stepSize;         
  }
}
  
if (upStickState == LOW){                 
  if (posBend != 0){               // if not at the min
  posBend = posBend - stepSize;
  }
}
    
if (rightStickState == LOW){                 
  if (posTwist > 0){
  posTwist = posTwist - stepSize;
  }
}

if (leftStickState == LOW){                
  if (posTwist < 180){
  posTwist = posTwist + stepSize;
  }
}

if (rightButtonState == LOW){                 //left button controlls both arms
  if (posHead > 180){
  dirHead = -dirHead;
  }
  else if (posHead == 0){
     dirHead = -dirHead;
  }
  posHead = posHead + (dirHead * stepSize);
}

// write positions //
servoArmL.write(posArmL);
servoArmR.write(posArmR);
servoBend.write(posBend);
servoTwist.write(posTwist);
servoHead.write(posHead);

// servos move now //
delay(moveTime);

/*
//detach all servos
servoHead.detach();
servoArmR.detach();
servoArmL.detach();
servoBend.detach();
servoTwist.detach();
*/

//reset all button states /// for good luck
leftButtonState = HIGH;          // 1 = open
leftStickState =  HIGH;         // 0 = closed
rightStickState = HIGH;
upStickState = HIGH;
downStickState = HIGH;
rightButtonState = HIGH; 

//delay (1000); //debug
    
}

